<template>
	<f7-page 
        name="panicgroup" 
        @page:beforein="onPageBeforeIn" 
        @page:beforeout="onPageBeforeOut"
        ptr 
        @ptr:refresh="onPageRefresh">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large title-large="Grup Panik">
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title class="show-small-title">Tombol Panik</f7-nav-title>
            <f7-nav-right>
                <f7-link href="/panic/groups/create/" icon-f7="add" color="smoothgray" icon-only></f7-link>
            </f7-nav-right>
		</f7-navbar>
        <f7-list media-list no-hairlines v-if="!panicLoading && panics.length > 0">
			<f7-list-item 
                link
                v-for="(item, index) in panics"
                :key="index"
                @click="showActionSheet($event, item)">
				<img v-if="item.media == null" slot="media" :src="require('../assets/no-group-photo.png')" width="48" class="img-circle">
                <img v-else slot="media" :src="item.media.url.small" width="48" class="img-circle">
				<div slot="title">{{ item.name }}</div>
                <div slot="subtitle" v-if="item.description != null"><small>{{ item.description }}</small></div>
                <div slot="after-title" class="item-after" v-if="isAuthor(item) == true">
                    <f7-badge class="bg-red color-white">Author</f7-badge>
                </div>
                <div slot="after-title" class="item-after" v-else-if="getUserStatus(item) == 'waiting'"><f7-icon f7="email" class="color-red"></f7-icon></div>
				<div slot="text"><small>{{ translatePanicGroup(item.panic_group) }}, {{ item.total_participant }} anggota</small></div>
			</f7-list-item>         
		</f7-list>
        <f7-block v-else-if="!panicLoading" style="height: calc(100% - 100px)">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="touch_app" style="font-size:100px;color:#eee;"></f7-icon>
						<span class="display-block">It's a little quiet here</span>
					</span>
				</span>
			</span>
		</f7-block>
		<f7-list media-list no-hairlines v-else-if="panicLoading">
            <f7-list-item
                class="skeleton-text skeleton-effect-blink"
                title="Full Name"
                subtitle="Lorem ipsum dolor sit amet"
                after="31 Juli 2019"
                text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi lobortis et massa ac interdum. Cras consequat felis at consequat hendrerit. Aliquam vestibulum vitae lorem ac iaculis. Praesent nec pharetra massa, at blandit lectus. Sed tincidunt, lectus eu convallis elementum, nibh nisi aliquet urna, nec imperdiet felis sapien at enim."
            >
                <f7-skeleton-block style="width: 48px; height: 48px; border-radius: 50%" slot="media"></f7-skeleton-block>
            </f7-list-item>
        </f7-list>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { setTimeout } from 'timers';
import { hoursAgo, parseError } from '../js/utils';
export default {
    name: 'PanicGroups',
    data(){
        return {
            panicLoading: true
        }
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('panic', [
            'panics'
        ])
    },
    methods: {
        hoursAgo,
        translatePanicGroup(group){
            if(group == 'community'){
                return 'Komunitas'
            }else if(group == 'family'){
                return 'Keluarga'
            }else if(group == 'friendship'){
                return 'Pertemanan'
            }else if(group == 'work'){
                return 'Pekerjaan'
            }else if(group == 'residential'){
                return 'Perumahan'
            }
        },
        isAuthor(panic){
            const self = this;
            return panic.author.id == self.user.id;
        },
        getUserStatus(panic){
            const self = this;

            let status = null;

            for(const x of panic.participants){
                if(x.user.id == self.user.id){
                    status = x.status;                    
                }
            }
            return status;
        },
        getPanics(){
            const self = this;

            self.$store.dispatch('panic/getPanics', {
                author: self.user.id,
                page: 1,
                perpage: 100,
                only: 'id,panic_group,name,description,media,author.id,author.phone,author.profile.fullname,author.profile.initial,author.profile.media,total_participant,total_comment,total_report,participants.id,participants.status,participants.user.id,participants.user.profile.fullname'
            }).then(()=>{
                setTimeout(()=>{
                    self.panicLoading = false;
                }, 100);
            });
        },
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;

            self.getPanics();
        },
        onPageBeforeOut(){
            const self = this;
            const app = self.$f7;
        },
        onPageRefresh(e, done){
			const self = this;
			const app = self.$f7;

            self.panicLoading = true;
            self.getPanics();
			done();	
		},
        showActionSheet(e, item){
            const self = this;
            const app = self.$f7;

            let status = self.getUserStatus(item);

            if(self.isAuthor(item)){
                var buttons = [{
                    text: item.name+'<br>'+item.description,
                    label: true
                }, {
                    text: 'Diskusi',
                    close: true,
                    onClick: function(actions, e){
                        self.$f7router.navigate('/panic/groups/view/'+item.id+'/', {
                            ignoreCache: true
                        });
                    }
                }, {
                    text: 'Ubah',
                    close: true,
                    onClick: function(actions, e){
                        self.$f7router.navigate('/panic/groups/edit/'+item.id+'/', {
                            ignoreCache: true
                        });
                    }
                }, {
                    text: 'Hapus',
                    close: true,
                    onClick: function(actions, e){
                        app.dialog.confirm('Anda akan menghapus grup panik '+item.name+'. Anda yakin?', 'RingSatu', function(){
                            app.preloader.show('green');

                            self.$store.dispatch('panic/deletePanic', {
                                id: item.id
                            }).then((response)=>{
                                app.preloader.hide();
                                if('errors' in response){
                                    let error = parseError(response.errors);
                                    app.dialog.alert(error.messages, 'RingSatu');
                                    return false;
                                }else{
                                    self.$f7router.refreshPage();
                                }
                            });
                        });
                    }
                }, {
                    text: 'Batal',
                    color: 'red',
                    close: true
                }];
            }else{
                if(status == 'waiting'){

                    var buttons = [{
                        text: 'Undangan Panik Good Father',
                        label: true
                    }, {
                        text: 'Setujui',
                        close: true,
                        onClick: function(actions, e){
                            app.dialog.confirm('Setujui untuk bergabung di grup panik '+item.name+'?', 'RingSatu', function(){
                                app.preloader.show('green');

                                self.$store.dispatch('panic/updatePanicInvitation', {
                                    id: item.id,
                                    status: 'approved'
                                }).then((response)=>{
                                    app.preloader.hide();
                                    if('errors' in response){
                                        let error = parseError(response.errors);
                                        app.dialog.alert(error.messages, 'RingSatu');
                                        return false;
                                    }else{
                                        self.$f7router.refreshPage();
                                    }
                                });
                            });
                        }
                    }, {
                        text: 'Tolak',
                        close: true,
                        onClick: function(actions, e){
                            app.dialog.confirm('Tolak undangan grup panik '+item.name+'?', 'RingSatu', function(){
                                app.preloader.show('green');

                                self.$store.dispatch('panic/updatePanicInvitation', {
                                    id: item.id,
                                    status: 'rejected'
                                }).then((response)=>{
                                    app.preloader.hide();
                                    if('errors' in response){
                                        let error = parseError(response.errors);
                                        app.dialog.alert(error.messages, 'RingSatu');
                                        return false;
                                    }else{
                                        self.$f7router.refreshPage();
                                    }
                                });
                            })
                        }
                    }, {
                        text: 'Batal',
                        color: 'red',
                        close: true
                    }];

                }else if(status == 'approved'){
                    var buttons = [{
                        text: item.name+'<br>'+item.description,
                        label: true
                    }, {
                        text: 'Diskusi',
                        close: true,
                        onClick: function(actions, e){
                            self.$f7router.navigate('/panic/groups/view/'+item.id+'/', {
                                ignoreCache: true
                            });
                        }
                    }, {
                        text: 'Keluar Grup',
                        close: true,
                        onClick: function(actions, e){
                            app.dialog.confirm('Keluar dari grup panik '+ item.name+'?', 'RingSatu', function(){
                                app.preloader.show('green');

                                self.$store.dispatch('panic/updatePanicInvitation', {
                                    id: item.id,
                                    status: 'rejected'
                                }).then((response)=>{
                                    app.preloader.hide();
                                    if('errors' in response){
                                        let error = parseError(response.errors);
                                        app.dialog.alert(error.messages, 'RingSatu');
                                        return false;
                                    }else{
                                        self.$f7router.refreshPage();
                                    }
                                });
                            });
                        }
                    }, {
                        text: 'Batal',
                        color: 'red',
                        close: true
                    }];
                }
            }

            let actionSheet = app.actions.create({
                buttons: buttons
            }).open();
        }
    }
}
</script>
